﻿@page "/chatbots/create"
@page "/chatbots/{Id:int}/edit"

@if (isAdmin)
{
    <PageTitle>JWobot Admin | ChatBot Form</PageTitle>
    <div class="d-sm-flex align-items-center justify-content-between mb-4">
        <h1 class="h3 mb-0 text-gray-800">ChatBot Form</h1>
    </div>
}
else
{
    <PageTitle>JWobot Admin | @cbModel.Name</PageTitle>
    <div class="d-sm-flex align-items-center justify-content-between mb-4">
        <h1 class="h3 mb-0 text-gray-800">@cbModel.Name</h1>
    </div>
}
<div class="card shadow mb-4">
    <div class="card-body">
        <EditForm Model="@cbModel" OnValidSubmit="@HandleValidSubmit" OnInvalidSubmit="@HandleInvalidSubmit">
            <DataAnnotationsValidator />
            <ValidationSummary />
            @if (isAdmin)
            {
                <div class="row">
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Name</label>
                            <InputText @bind-Value="cbModel.Name" class="form-control" />
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Company</label>
                            <InputText @bind-Value="cbModel.Company" class="form-control" max="100" />
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="form-group">
                            <label>Token</label>
                            <div class="input-group">
                                <InputText @bind-Value="cbModel.Token" class="form-control" max="50" />
                                <div class="input-group-append">
                                    <button class="btn btn-dark" type="button" @onclick="HandleGenerateToken">Generate</button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-12 mb-3">
                        <InputCheckbox @bind-Value="cbModel.IsActive"></InputCheckbox> Active
                    </div>
                </div>
            }
            <div class="row">
                <div class="col-md-12">
                    <div class="form-group">
                        <label>Fallback Message</label>
                        <InputTextArea @bind-Value="cbModel.FallbackMessage" class="form-control" rows="@(isAdmin ? 5 : 10)" />
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <div class="form-group">
                        <label>Data</label>
                        <InputTextArea @bind-Value="cbModel.Data" class="form-control" rows="@(isAdmin ? 10 : 20)" />
                    </div>
                </div>
            </div>
            <div class="form-group mt-3">
                @if (Id.HasValue && isAdmin)
                {
                    <button type="button" class="btn btn-danger" @onclick="Delete">Delete</button>
                }
                <button type="submit" class="btn btn-primary float-right ">Save</button>
            </div>
        </EditForm>
    </div>
</div>

@code {
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }
    private string email;
    private bool isAdmin = false;
    public string pageTitle = "Create ChatBot";

    [Parameter]
    public int? Id { get; set; }
    private bool isSaving = false;

    private ChatBotModel cbModel = new ChatBotModel();

    protected async override Task OnInitializedAsync()
    {
        await JS.ShowLoader();
        var claimsPrincipal = (await authenticationStateTask).User;
        if (claimsPrincipal != null)
        {
            email = ((CustomAuthenticationStateProvider)AuthenticationStateProvider).GetCurrentUserEmail(claimsPrincipal);
            isAdmin = claimsPrincipal.IsInRole("Admin");
        }
        if (Id.HasValue)
        {
            pageTitle = "Update ChatBot";
            cbModel = Mapper.Map<ChatBotModel>(ChatBotService.GetById(Id.Value));
        }
        await JS.HideLoader();
    }

    protected async Task HandleInvalidSubmit()
    {
        await JS.ShowError(pageTitle, "Please complete all requried fields");
    }

    private async Task HandleValidSubmit()
    {
        if (!isSaving)
        {
            isSaving = true;
            await JS.ShowLoader();

            try
            {
                var cb = Mapper.Map<ChatBot>(cbModel);
                var action = "created";

                if (Id.HasValue)
                {
                    action = "updated";
                    cb.Id = Id.Value;
                    cb.ModifiedBy = email;
                    if (isAdmin)
                    {
                        await ChatBotService.Update(cb);
                    }
                    else
                    {
                        await ChatBotService.UpdateData(cb);
                    }
                }
                else
                {
                    cb.CreatedBy = email;
                    await ChatBotService.Create(cb);
                }
                await JS.ShowSuccess(pageTitle, $"ChatBot successfully {action}");
                Navigation.NavigateTo("/chatbots");
            }
            catch (Exception ex)
            {
                await JS.ShowError(pageTitle, ex.Message.ToString());
            }
            await JS.HideLoader();
            isSaving = false;
        }
    }

    private async Task Delete()
    {
        await ChatBotService.Delete(Id.Value);
        await JS.ShowSuccess(pageTitle, $"ChatBot successfully deleted");
        Navigation.NavigateTo("chatbots");
    }

    private void HandleGenerateToken()
    {
        cbModel.Token = RandomString(15);
    }
    private string RandomString(int length)
    {
        const string chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        var random = new Random();
        return new string(Enumerable.Repeat(chars, length)
          .Select(s => s[random.Next(s.Length)]).ToArray());
    }
}
